package org.yarrahouse;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.border.EmptyBorder;

public class AboutDialog extends JDialog
{

    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private final JPanel contentPanel = new JPanel();

    /**
     * Launch the application.
     */
    public static void main(String[] args)
    {
        try
        {
            AboutDialog dialog = new AboutDialog();
            dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
            dialog.setVisible(true);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    /**
     * Create the dialog.
     */
    public AboutDialog()
    {
        setType(Type.POPUP);
        setTitle(Messages.getString("AboutDialog.title")); //$NON-NLS-1$
        setResizable(false);
        setModal(true);
        setBounds(100, 100, 450, 300);
        getContentPane().setLayout(new BorderLayout());
        contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
        getContentPane().add(contentPanel, BorderLayout.CENTER);
        
        JTextArea txtrAFileConcatinator = new JTextArea();
        txtrAFileConcatinator.setEditable(false);
        txtrAFileConcatinator.setLineWrap(true);
        txtrAFileConcatinator.setWrapStyleWord(true);
        txtrAFileConcatinator.setForeground(new Color(0, 0, 255));
        txtrAFileConcatinator.setBackground(Color.WHITE);
        txtrAFileConcatinator.setFont(txtrAFileConcatinator.getFont().deriveFont(txtrAFileConcatinator.getFont().getSize() + 26f));
        txtrAFileConcatinator.setText(Messages.getString("AboutDialog.logo")); //$NON-NLS-1$
        
        JTextArea txtrAuthorJonHornstein = new JTextArea();
        txtrAuthorJonHornstein.setEditable(false);
        txtrAuthorJonHornstein.setText(Messages.getString("AboutDialog.identification")); //$NON-NLS-1$
        GroupLayout gl_contentPanel = new GroupLayout(contentPanel);
        gl_contentPanel.setHorizontalGroup(
            gl_contentPanel.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPanel.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(gl_contentPanel.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_contentPanel.createSequentialGroup()
                            .addComponent(txtrAFileConcatinator, GroupLayout.DEFAULT_SIZE, 412, Short.MAX_VALUE)
                            .addContainerGap())
                        .addGroup(gl_contentPanel.createSequentialGroup()
                            .addGap(91)
                            .addComponent(txtrAuthorJonHornstein, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                            .addGap(89))))
        );
        gl_contentPanel.setVerticalGroup(
            gl_contentPanel.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPanel.createSequentialGroup()
                    .addComponent(txtrAFileConcatinator, GroupLayout.PREFERRED_SIZE, 163, GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(ComponentPlacement.RELATED, 11, Short.MAX_VALUE)
                    .addComponent(txtrAuthorJonHornstein, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
        );
        contentPanel.setLayout(gl_contentPanel);
        {
            JPanel buttonPane = new JPanel();
            buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
            getContentPane().add(buttonPane, BorderLayout.SOUTH);
            {
                JButton okButton = new JButton(Messages.getString("AboutDialog.ok")); //$NON-NLS-1$
                okButton.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent arg0) {
                        setVisible(false);
                    }
                });
                okButton.setActionCommand(Messages.getString("AboutDialog.ok")); //$NON-NLS-1$
                buttonPane.add(okButton);
                getRootPane().setDefaultButton(okButton);
            }
        }
    }
}
