/**
 * 
 */
package org.yarrahouse;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import javax.swing.SwingWorker;

/**
 * @author Jon
 *
 */
public class FilesMergeTask extends SwingWorker<Void, Void>
{
private
List<File> filesToMerge;
File       outputFile;

    FilesMergeTask(List<File> filesToMerge, File outputFile) 
    {
        this.filesToMerge = filesToMerge;
        this.outputFile   = outputFile;
    }
    /*
     * find the size of all the files
     */
    /**
     * @return
     */
    protected 
    long totalSizeOfFiles ()
    {
    long lFileSizes = 0L;
    
        // get the size for progress
        for(File file : filesToMerge)
        {  
            lFileSizes += file.length();
        }
        return lFileSizes;
    }
    /**
     * 
     */
    void mergeFiles ()
    {
    FileOutputStream outputStream;
    long             lBytesRead = 0L,
                     lFileSizes = totalSizeOfFiles();

        try
        {
            outputStream = new FileOutputStream(outputFile, false); // overwrite the file
            // Concatenate the files
            for(File file : filesToMerge)
            {  
            InputStream input = null;

                input = new FileInputStream(file);
                byte[] buf = new byte[1024];
                int bytesRead;
                while ((bytesRead = input.read(buf)) > 0 && !isCancelled()) 
                {
                    outputStream.write(buf, 0, bytesRead);
                    lBytesRead += bytesRead;
                    setProgress((int)((100*lBytesRead)/lFileSizes));
                }
                input.close();
            } 
            outputStream.close();
        }
        catch (IOException e1)
        {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }
    }
    /* (non-Javadoc)
     * @see javax.swing.SwingWorker#doInBackground()
     */
    @Override
    protected Void doInBackground() throws Exception
    {
        mergeFiles();
        return null;
    }
    @Override
    protected void done() 
    {
       try 
       {
           setProgress(0);
       }
       catch (Exception ignore) 
       {
       }
   }

}